> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an API key

> Creates a new API key with specific permissions and restrictions.

**Requires Admin API key**


## OpenAPI

````yaml specs/search.yml post /1/keys
openapi: 3.1.0
info:
  title: Search API
  summary: >-
    The Algolia Search API lets you search, configure, and manage your indices
    and records
  description: >
    ## Client libraries


    Use Algolia's API clients and libraries to reliably integrate Algolia's APIs
    with your apps.

    The official API clients are covered by Algolia's [Service Level
    Agreement](https://www.algolia.com/policies/sla).


    For more information, see [Algolia's
    ecosystem](https://www.algolia.com/doc/libraries).


    ## Base URLs


    Base URLs for the Search API:


    - `https://{APPLICATION_ID}.algolia.net`

    - `https://{APPLICATION_ID}-dsn.algolia.net`.
      If your subscription includes a [Distributed Search Network](https://dashboard.algolia.com/infra),
      this ensures that requests are sent to servers closest to users.

    Both URLs provide high availability by distributing requests with load
    balancing.


    **All requests must use HTTPS.**


    ## Retry strategy


    To guarantee high availability, implement a retry strategy for all API
    requests using the URLs of your servers as fallbacks:


    - `https://{APPLICATION_ID}-1.algolianet.com`

    - `https://{APPLICATION_ID}-2.algolianet.com`

    - `https://{APPLICATION_ID}-3.algolianet.com`


    These URLs use a different DNS provider than the primary URLs.

    Randomize this list to ensure an even load across the three servers.


    All Algolia API clients implement this retry strategy.


    ## Authentication


    Add these headers to authenticate requests:


    - `x-algolia-application-id`. Your Algolia application ID.

    - `x-algolia-api-key`. An API key with the necessary permissions to make the
    request.
      The required access control list (ACL) to make a request is listed in each endpoint's reference.

    You can find your application ID and API key in the [Algolia
    dashboard](https://dashboard.algolia.com/account/api-keys).


    ## Request format


    Depending on the endpoint, request bodies are either JSON objects or arrays
    of JSON objects.


    ## Parameters


    Parameters are passed as query parameters for GET and DELETE requests,

    and in the request body for POST and PUT requests.


    Query parameters must be
    [URL-encoded](https://developer.mozilla.org/en-US/docs/Glossary/Percent-encoding).

    Non-ASCII characters must be UTF-8 encoded.

    Plus characters (`+`) are interpreted as spaces.

    Arrays as query parameters must be one of:


    - A comma-separated string: `attributesToRetrieve=title,description`

    - A URL-encoded JSON array:
    `attributesToRetrieve=%5B%22title%22,%22description%22%D`


    ## Response status and errors


    The Search API returns JSON responses.

    Since JSON doesn't guarantee any specific ordering, don't rely on the order
    of attributes in the API response.


    Successful responses return `2xx` statuses. Client errors return `4xx`
    statuses. Server errors return `5xx` statuses.

    Error responses have a `message` property with more information.


    ## Version


    The current version of the Search API is version 1, indicated by the `/1/`
    in each endpoint's URL.
  version: 1.0.0
servers:
  - url: https://{appId}.algolia.net
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-1.algolianet.com
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-2.algolianet.com
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-3.algolianet.com
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
  - url: https://{appId}-dsn.algolia.net
    variables:
      appId:
        default: ALGOLIA_APPLICATION_ID
security:
  - appId: []
    apiKey: []
tags:
  - name: Advanced
    description: Query your logs.
  - name: Api Keys
    x-displayName: API keys
    description: >
      Manage your API keys.


      API requests must be authenticated with an API key.

      API keys can have permissions (access control lists, ACL) and
      restrictions.
    externalDocs:
      url: https://www.algolia.com/doc/guides/security/api-keys
      description: API keys.
  - name: Clusters
    description: |
      Multi-cluster operations.

      Multi-cluster operations are **deprecated**.
      If you have issues with your Algolia infrastructure
      due to large volumes of data, contact the Algolia support team.
  - name: Dictionaries
    description: >
      Manage your dictionaries.


      Customize language-specific settings, such as stop words, plurals, or word
      segmentation.


      Dictionaries are application-wide.
    externalDocs:
      url: >-
        https://www.algolia.com/doc/guides/managing-results/optimize-search-results/handling-natural-languages-nlp
      description: Natural languages.
  - name: Indices
    description: >
      Manage your indices and index settings.


      Indices are copies of your data that are stored on Algolia's servers.

      They're optimal data structures for fast search and are made up of records
      and settings.
    externalDocs:
      url: >-
        https://www.algolia.com/doc/guides/sending-and-managing-data/manage-indices-and-apps/manage-indices
      description: Manage your indices.
  - name: Records
    description: >
      Add, update, and delete records from your indices.


      Records are individual items in your index.

      When they match a search query, they're returned as search results, in the
      order determined by your ranking.

      Records are schemaless JSON objects.

      When adding or updating many records, check the [indexing rate
      limits](https://support.algolia.com/hc/articles/4406975251089-Is-there-a-rate-limit-for-indexing-on-Algolia).
    externalDocs:
      url: >-
        https://www.algolia.com/doc/guides/sending-and-managing-data/prepare-your-data
      description: Prepare your records.
  - name: Rules
    description: >
      Create, update, delete, and search for rules.


      Rules are _if-then_ statements that you can use to curate search results.

      Rules have _conditions_ that can trigger _consequences_.

      Consequences are changes to the search results, such as changing the order
      of search results or boosting a facet.

      This can be useful for tuning specific queries or for merchandising.
    externalDocs:
      url: https://www.algolia.com/doc/guides/managing-results/rules/rules-overview
      description: Index Rules.
  - name: Search
    description: Search one or more indices for matching records or facet values.
  - name: Synonyms
    description: |
      Create, update, delete, and search for synonyms.

      Synonyms are terms that the search engine should consider equal.
    externalDocs:
      url: >-
        https://www.algolia.com/doc/guides/managing-results/optimize-search-results/adding-synonyms
      description: Synonyms.
  - name: Vaults
    description: >-
      Algolia Vault lets you restrict access to your clusters to specific IP
      addresses and provides disk-level encryption at rest.
    externalDocs:
      url: https://www.algolia.com/doc/guides/security/algolia-vault
      description: Algolia Vault.
  - name: _model_index_settings
    x-displayName: Index settings
    description: |
      <SchemaDefinition schemaRef="#/components/schemas/indexSettings" />.
paths:
  /1/keys:
    post:
      tags:
        - Api Keys
      summary: Create an API key
      description: Creates a new API key with specific permissions and restrictions.
      operationId: addApiKey
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/apiKey'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/addApiKeyResponse'
        '400':
          $ref: '#/components/responses/BadRequest'
        '402':
          $ref: '#/components/responses/FeatureNotEnabled'
        '403':
          $ref: '#/components/responses/MethodNotAllowed'
        '404':
          $ref: '#/components/responses/IndexNotFound'
      x-codeSamples:
        - lang: csharp
          label: C#
          source: >-
            // Initialize the client

            var client = new SearchClient(new
            SearchConfig("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY"));


            // Call the API

            var response = await client.AddApiKeyAsync(
              new ApiKey
              {
                Acl = new List<Acl> { Enum.Parse<Acl>("Search"), Enum.Parse<Acl>("AddObject") },
                Description = "my new api key",
              }
            );


            // print the response

            Console.WriteLine(response);
        - lang: dart
          label: Dart
          source: |-
            // Initialize the client
            final client =
                SearchClient(appId: 'ALGOLIA_APPLICATION_ID', apiKey: 'ALGOLIA_API_KEY');

            // Call the API
            final response = await client.addApiKey(
              apiKey: ApiKey(
                acl: [
                  Acl.fromJson("search"),
                  Acl.fromJson("addObject"),
                ],
                description: "my new api key",
              ),
            );

            // print the response
            print(response);
        - lang: go
          label: Go
          source: >-
            // Initialize the client

            client, err := search.NewClient("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY")

            if err != nil {
              // The client can fail to initialize if you pass an invalid parameter.
              panic(err)
            }


            // Call the API

            response, err := client.AddApiKey(client.NewApiAddApiKeyRequest(

              search.NewEmptyApiKey().SetAcl(
                []search.Acl{search.Acl("search"), search.Acl("addObject")}).SetDescription("my new api key")))
            if err != nil {
              // handle the eventual error
              panic(err)
            }



            // print the response

            print(response)
        - lang: java
          label: Java
          source: >-
            // Initialize the client

            SearchClient client = new SearchClient("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY");


            // Call the API

            AddApiKeyResponse response = client.addApiKey(
              new ApiKey().setAcl(Arrays.asList(Acl.SEARCH, Acl.ADD_OBJECT)).setDescription("my new api key")
            );


            // print the response

            System.out.println(response);
        - lang: javascript
          label: JavaScript
          source: >-
            // Initialize the client

            const client = algoliasearch('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY');


            // Call the API

            const response = await client.addApiKey({ acl: ['search',
            'addObject'], description: 'my new api key' });



            // print the response

            console.log(response);
        - lang: kotlin
          label: Kotlin
          source: >-
            // Initialize the client

            val client = SearchClient(appId = "ALGOLIA_APPLICATION_ID", apiKey =
            "ALGOLIA_API_KEY")


            // Call the API

            var response =
              client.addApiKey(
                apiKey =
                  ApiKey(
                    acl =
                      listOf(
                        Acl.entries.first { it.value == "search" },
                        Acl.entries.first { it.value == "addObject" },
                      ),
                    description = "my new api key",
                  )
              )


            // print the response

            println(response)
        - lang: php
          label: PHP
          source: >-
            // Initialize the client

            $client = SearchClient::create('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY');


            // Call the API

            $response = $client->addApiKey(
                ['acl' => [
                    'search',

                    'addObject',
                ],
                    'description' => 'my new api key',
                ],
            );



            // print the response

            var_dump($response);
        - lang: python
          label: Python
          source: >-
            # Initialize the client

            # In an asynchronous context, you can use SearchClient instead,
            which exposes the exact same methods.

            client = SearchClientSync("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY")


            # Call the API

            response = client.add_api_key(
                api_key={
                    "acl": [
                        "search",
                        "addObject",
                    ],
                    "description": "my new api key",
                },
            )



            # print the response

            print(response)
        - lang: ruby
          label: Ruby
          source: >-
            # Initialize the client

            client = Algolia::SearchClient.create("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY")


            # Call the API

            response = client.add_api_key(
              Algolia::Search::ApiKey.new(acl: ["search", "addObject"], description: "my new api key")
            )



            # print the response

            puts(response)
        - lang: scala
          label: Scala
          source: >-
            // Initialize the client

            val client = SearchClient(appId = "ALGOLIA_APPLICATION_ID", apiKey =
            "ALGOLIA_API_KEY")


            // Call the API

            val response = Await.result(
              client.addApiKey(
                apiKey = ApiKey(
                  acl = Seq(Acl.withName("search"), Acl.withName("addObject")),
                  description = Some("my new api key")
                )
              ),
              Duration(100, "sec")
            )


            // print the response

            println(response)
        - lang: swift
          label: Swift
          source: >-
            // Initialize the client

            let client = try SearchClient(appID: "ALGOLIA_APPLICATION_ID",
            apiKey: "ALGOLIA_API_KEY")


            // Call the API

            let response = try await client.addApiKey(apiKey: ApiKey(
                acl: [Acl.search, Acl.addObject],
                description: "my new api key"
            ))


            // print the response

            print(response)
        - lang: cURL
          label: curl
          source: |-
            curl --request POST \
              --url https://algolia_application_id.algolia.net/1/keys \
              --header 'accept: application/json' \
              --header 'content-type: application/json' \
              --header 'x-algolia-api-key: ALGOLIA_API_KEY' \
              --header 'x-algolia-application-id: ALGOLIA_APPLICATION_ID' \
              --data '
            {
              "acl": [
                "search",
                "addObject"
              ],
              "description": "Used for indexing by the CLI",
              "indexes": [
                "dev_*",
                "prod_en_products"
              ],
              "maxHitsPerQuery": 0,
              "maxQueriesPerIPPerHour": 0,
              "queryParameters": "typoTolerance=strict&restrictSources=192.168.1.0/24",
              "referers": [
                "*algolia.com*"
              ],
              "validity": 86400
            }
            '
components:
  schemas:
    apiKey:
      type: object
      description: API key object.
      additionalProperties: false
      properties:
        acl:
          type: array
          description: >
            Permissions that determine the type of API requests this key can
            make.

            The required ACL is listed in each endpoint's reference.

            For more information, see [access control
            list](https://www.algolia.com/doc/guides/security/api-keys/#access-control-list-acl).
          example:
            - search
            - addObject
          default: []
          items:
            $ref: '#/components/schemas/acl'
        description:
          type: string
          description: Description of an API key to help you identify this API key.
          example: Used for indexing by the CLI
          default: ''
        indexes:
          type: array
          description: >
            Index names or patterns that this API key can access.

            By default, an API key can access all indices in the same
            application.


            You can use leading and trailing wildcard characters (`*`):


            - `dev_*` matches all indices starting with "dev_"

            - `*_dev` matches all indices ending with "_dev"

            - `*_products_*` matches all indices containing "_products_".
          example:
            - dev_*
            - prod_en_products
          default: []
          items:
            type: string
        maxHitsPerQuery:
          type: integer
          description: |
            Maximum number of results this API key can retrieve in one query.
            By default, there's no limit.
          default: 0
        maxQueriesPerIPPerHour:
          type: integer
          description: >
            Maximum number of API requests allowed per IP address or [user
            token](https://www.algolia.com/doc/guides/sending-events/concepts/usertoken)
            per hour.


            If this limit is reached, the API returns an error with status code
            `429`.

            By default, there's no limit.
          default: 0
        queryParameters:
          type: string
          description: >
            Query parameters to add when making API requests with this API key.


            To restrict this API key to specific IP addresses, add the
            `restrictSources` parameter.

            You can only add a single source, but you can provide a range of IP
            addresses.


            Creating an API key fails if the request is made from an IP address
            outside the restricted range.
          example: typoTolerance=strict&restrictSources=192.168.1.0/24
          default: ''
        referers:
          type: array
          description: >
            Allowed HTTP referrers for this API key.


            By default, all referrers are allowed.

            You can use leading and trailing wildcard characters (`*`):


            - `https://algolia.com/*` allows all referrers starting with
            "https://algolia.com/"

            - `*.algolia.com` allows all referrers ending with ".algolia.com"

            - `*algolia.com*` allows all referrers in the domain "algolia.com".


            Like all HTTP headers, referrers can be spoofed. Don't rely on them
            to secure your data.

            For more information, see [HTTP referrer
            restrictions](https://www.algolia.com/doc/guides/security/security-best-practices/#http-referrers-restrictions).
          example:
            - '*algolia.com*'
          default: []
          items:
            type: string
        validity:
          type: integer
          description: |
            Duration (in seconds) after which the API key expires.
            By default, API keys don't expire.
          example: 86400
          default: 0
      required:
        - acl
    addApiKeyResponse:
      type: object
      additionalProperties: false
      properties:
        createdAt:
          $ref: '#/components/schemas/createdAt'
        key:
          $ref: '#/components/schemas/keyString'
      required:
        - key
        - createdAt
    acl:
      description: Access control list permissions.
      type: string
      enum:
        - addObject
        - analytics
        - browse
        - deleteObject
        - deleteIndex
        - editSettings
        - inference
        - listIndexes
        - logs
        - personalization
        - recommendation
        - search
        - seeUnretrievableAttributes
        - settings
        - usage
        - nluWriteProject
        - nluReadProject
        - nluWriteEntity
        - nluReadEntity
        - nluWriteIntent
        - nluReadIntent
        - nluPrediction
        - nluReadAnswers
    createdAt:
      type: string
      example: '2023-07-04T12:49:15Z'
      description: Date and time when the object was created, in RFC 3339 format.
    keyString:
      type: string
      description: API key.
      example: 13ad45b4d0a2f6ea65ecbddf6aa260f2
    ErrorBase:
      description: Error.
      type: object
      x-keep-model: true
      additionalProperties: true
      properties:
        message:
          type: string
          example: Invalid Application-Id or API-Key
  responses:
    BadRequest:
      description: Bad request or request arguments.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorBase'
    FeatureNotEnabled:
      description: This feature is not enabled on your Algolia account.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorBase'
    MethodNotAllowed:
      description: Method not allowed with this API key.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorBase'
    IndexNotFound:
      description: Index not found.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorBase'
  securitySchemes:
    appId:
      type: apiKey
      in: header
      name: x-algolia-application-id
      description: Your Algolia application ID.
    apiKey:
      type: apiKey
      in: header
      name: x-algolia-api-key
      description: >
        Your Algolia API key with the necessary permissions to make the request.

        Permissions are controlled through access control lists (ACL) and access
        restrictions.

        The required ACL to make a request is listed in each endpoint's
        reference.

````